﻿
using Newtonsoft.Json;
using System;
using System.Data;
using System.Linq;
using Wisej.Web;

namespace Wisej_Datagrid
{
    public partial class Window1 : Form
    {
        public Window1()
        {
            InitializeComponent();
        }

        private void Window1_Load(object sender, EventArgs e)
        {
            dg.AllowUserToResizeColumns = true;
            dg.BorderStyle = BorderStyle.Solid;
            dg.EditMode = DataGridViewEditMode.EditProgrammatically;// DataGridViewEditMode.EditOnEnter;
            dg.ReadOnly = true;
            dg.AllowUserToAddRows = false;
            dg.RowHeadersVisible = false;
            dg.AllowUserToOrderColumns = false;
            dg.ShowColumnVisibilityMenu = false;
            dg.DefaultRowHeight = 20;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            string serializedDt = System.IO.File.ReadAllText(@"c:\temp\exportData.txt");
            DataTable dt = JsonConvert.DeserializeObject<DataTable>(serializedDt);
            dg.DataSource = dt;
            button6_Click(sender, e);
        }

        private void Window1_Shown(object sender, EventArgs e)
        {
            dg.Left = 10; dg.Width = this.ClientArea.Width - 20; dg.Height = this.ClientArea.Height - dg.Top - 10;
        }



        private void button4_Click(object sender, EventArgs e)
        {
            var ds = dg.DataSource;
            dg.DataSource = null;
            for (int i = 0; i < dg.ColumnCount; i++)
                dg.Columns[i].DefaultCellStyle.WrapMode = DataGridViewTriState.True;
            dg.DataSource = ds;
            dg.AutoResizeRows();
        }

        private void button5_Click(object sender, EventArgs e)
        {
            var ds = dg.DataSource;
            dg.DataSource = null;
            for (int i = 0; i < dg.ColumnCount; i++)
                dg.Columns[i].DefaultCellStyle.WrapMode = DataGridViewTriState.True;
            dg.DataSource = ds;
            dg.AutoResizeRows();
        }

        private void button6_Click(object sender, EventArgs e)
        {
            int visible = 0;
            for (int i = 0; i < dg.ColumnCount; i++)
                if (dg.Columns[i].Visible) visible++;
            for (int i = 0; i < dg.ColumnCount; i++)
                dg.Columns[i].Width = (dg.Width - 20) / visible;

        }
    }
}
